
using System.Xml;

/**
 * Processes the mono handbook to remove extra web-specific div sections.
 */
public class MonoHBHelpSource: XhtmlHelpSource
{
	public MonoHBHelpSource (string base_file, bool create) : base (base_file, create)
	{
	}
	
	public override XmlDocument ProcessContent(XmlDocument docToProcess)
	{
		XmlNodeList nodeList = docToProcess.GetElementsByTagName("div");
		
		/* Remove the mono handbook specific decorations */
        foreach(XmlNode node in nodeList)
		{
			string cssClass = ((XmlElement)node).GetAttribute("class");
			if (cssClass != null && (cssClass == "topframe" || cssClass == "navbar" || cssClass == "copyright"))
			{
				node.RemoveAll();
			}
                                                                                
		}
                                                                                

	string headinginner = "Mono Handbook";
	XmlNode firstheading = null;

	try {
		firstheading =  docToProcess.GetElementsByTagName("h1")[0];
		headinginner = firstheading.InnerXml;
        }
                                                                                
        catch {

		try {

                firstheading =  docToProcess.GetElementsByTagName("h2")[0];
                headinginner = firstheading.InnerXml;

		}
		catch {}
        }


try {

	XmlNode bodynode =  docToProcess.GetElementsByTagName("body")[0];
	if (firstheading != null)
		bodynode.RemoveChild(firstheading);

	bodynode.InnerXml =	"<table width=\"100%\">" +
			"<tr bgcolor=\"#b0c4dae\"><td><i></i>Mono Handbook<h3>" + headinginner + "</h3></td></tr></table><p />" +
	bodynode.InnerXml;
}
catch {
}

XmlNodeList nodeList2 = docToProcess.GetElementsByTagName("pre");
foreach(XmlNode node in nodeList2)
	{
		string cssClass = ((XmlElement)node).GetAttribute("class");

		if (cssClass != null)
		{

			switch(cssClass)       
			{         

			case "code":   

				node.InnerXml = "<table width='100%' border='0' cellspacing='0' cellpadding='3'><tr><td>" + 
					"<table width='100%' border='0' cellspacing='0' cellpadding='0' height='100%'>" + 
					"<tr><td bgcolor='#c0c0c0'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"<td bgcolor='#c0c0c0'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"<td bgcolor='#c0c0c0'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"</tr><tr> <td bgcolor='#c0c0c0'> </td><td width='100%' bgcolor='#efefef'> " + 
					"<table width='100%' border='0' cellspacing='0' cellpadding='0'><tr><td bgcolor='#ffffff'>" + 
					"<table width='100%' border='0' cellspacing='0' cellpadding='2'><tr><td bgcolor='#efefef'>" + 

					node.InnerXml +

					"</td></tr></table></td></tr></table></td><td bgcolor='#999999'><img src='images/shim.gif' width='1' height='1' /></td>" + 
					"</tr><tr> <td bgcolor='#c0c0c0'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"<td bgcolor='#c0c0c0'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"<td bgcolor='#c0c0c0'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"</tr></table></td></tr></table>";

			break;        
     	    		case "console":   

				node.InnerXml = "<table width='100%' border='0' cellspacing='0' cellpadding='3'><tr><td>" + 
					"<table width='100%' border='0' cellspacing='0' cellpadding='0' height='100%'>" + 
					"<tr><td bgcolor='#555555'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"<td bgcolor='#555555'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"<td bgcolor='#555555'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"</tr><tr> <td bgcolor='#c0c0c0'> </td><td width='100%' bgcolor='#efefef'> " + 
					"<table width='100%' border='0' cellspacing='0' cellpadding='0'><tr><td bgcolor='#ffffff'>" + 
					"<table width='100%' border='0' cellspacing='0' cellpadding='2'><tr><td bgcolor='#999999'>" + 

					node.InnerXml +

					"</td></tr></table></td></tr></table></td><td bgcolor='#999999'><img src='images/shim.gif' width='1' height='1' /></td>" + 
					"</tr><tr> <td bgcolor='#555555'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"<td bgcolor='#555555'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"<td bgcolor='#555555'><img src='images/empty.png' width='1' height='1' /></td>" + 
					"</tr></table></td></tr></table>";
			break;

			default:
			break;      
			}


		}
	}
		return docToProcess;
	}
}
